Index: npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest
===================================================================
--- npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision cd8630be6536b27ae1c762184795ee87723202ab)
+++ npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision 1ebb340be23e45ead361b729734f0e82007af6bd)
@@ -22319,5 +21987,32 @@
    for (i = 0;i < reciplist.len;++i) {
      substdio_puts(&smtpto,"RCPT TO:<");
-@@ -297,19 +843,14 @@
+@@ -246,15 +801,23 @@
+     substdio_flush(&smtpto);
+     code = smtpcode();
+     if (code >= 500) {
+-      out("h"); outhost(); out(" does not like recipient.\n");
++      /* added by Endersys R&D Team */
++      out("h<From:"); outsafe(&sender); out(" To:"); outsafe(&reciplist.sa[i]); out("> ");  outhost(); out(" does not like recipient.\n");
+       outsmtptext(); zero();
+     }
+     else if (code >= 400) {
+-      out("s"); outhost(); out(" does not like recipient.\n");
++      /* added by Endersys R&D Team */
++      out("s<From:"); outsafe(&sender); out(" To:"); outsafe(&reciplist.sa[i]);  out("> ");  outhost(); out(" does not like recipient.\n");
+       outsmtptext(); zero();
+     }
+     else {
+-      out("r"); zero();
++       /*
++       * James Raftery <james@now.ie>
++       * Log _real_ envelope recipient, post canonicalisation.
++       * and modified by Endersys R&D Team
++       */
++
++      out("r<From:"); outsafe(&sender); out(" To:"); outsafe(&reciplist.sa[i]); out("> "); zero();
+       flagbother = 1;
+     }
+   }
+@@ -297,19 +860,14 @@
    if (!stralloc_cats(saout,"@")) temp_nomem();
   
@@ -22341,5 +22036,5 @@
    if (control_readint(&timeout,"control/timeoutremote") == -1) temp_control();
    if (control_readint(&timeoutconnect,"control/timeoutconnect") == -1)
-@@ -324,48 +865,108 @@
+@@ -324,48 +882,108 @@
      case 1:
        if (!constmap_init(&maproutes,routes.s,routes.len,1)) temp_nomem(); break;
@@ -22469,5 +22164,5 @@
    if (ipme_init() != 1) temp_oserr();
   
-@@ -414,10 +1015,13 @@
+@@ -414,10 +1032,13 @@
      smtpfd = socket(AF_INET,SOCK_STREAM,0);
      if (smtpfd == -1) temp_oserr();
@@ -22487,5 +22182,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-rspawn.c netqmail-1.06/qmail-rspawn.c
 --- ../netqmail-1.06-original/qmail-rspawn.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-rspawn.c	2016-11-22 21:03:57.123527732 +0100
++++ netqmail-1.06/qmail-rspawn.c	2019-02-27 20:57:13.400024959 +0100
 @@ -1,3 +1,4 @@
 +#include "env.h"
@@ -22516,6 +22211,22 @@
 diff -ruN ../netqmail-1.06-original/qmail-send.9 netqmail-1.06/qmail-send.9
 --- ../netqmail-1.06-original/qmail-send.9	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-send.9	2016-11-22 21:03:57.123527732 +0100
-@@ -51,7 +51,9 @@
++++ netqmail-1.06/qmail-send.9	2019-06-26 16:45:05.514152928 +0200
+@@ -16,6 +16,15 @@
+ .B qmail-send
+ leaves it in the queue and tries the addresses again later.
+ 
++.B Supplemental queues
++allow more than one queue for remote recipients. (CHANNELS - 2) supplemental queues total, because one queue is always
++designated for local deliveries and a second queue is always available for remote deliveries that
++don't match any of the domains listed in the supplemental queue control files.
++This makes it possible to divide remote deliveries into distinct queues at different concurrency
++levels and can be used as a throttling mechanism based on domain.
++Supplemental queues are managed by the supplsX and concurrencysupplX control files, where X is an integer from
++0 to (CHANNELS - 3).
++
+ .B qmail-send
+ prints a readable record of its activities to descriptor 0.
+ It writes commands to
+@@ -51,7 +60,13 @@
  .B qmail-send
  receives a HUP signal,
@@ -22524,9 +22235,29 @@
 +.IR concurrencylocal ,
 +.IR concurrencyremote ,
-+.IR locals
++.IR locals,
++.IR supplsX,
++.IR concurrencylocal,
++.IR concurrencyremote,
++.IR concurrencysupplX
  and
  .IR virtualdomains .
  .TP 5
-@@ -115,6 +117,10 @@
+@@ -93,6 +108,15 @@
+ is limited at compile time to
+ SPAWN.
+ .TP 5
++.I concurrencysupplX
++Maximum number of simultaneous delivery attempts via supplemental
++channel X, where X is an integer starting at 0.
++Default: 20.
++If 0, deliveries via channel X will be put on hold.
++.I concurrencysupplX
++is limited at compile time to
++SPAWN.
++.TP 5
+ .I doublebouncehost
+ Double-bounce host.
+ Default:
+@@ -115,6 +139,10 @@
  (If that bounces,
  .B qmail-send
@@ -22539,16 +22270,44 @@
  .I envnoathost
  Presumed domain name for addresses without @ signs.
+@@ -147,6 +175,12 @@
+ is listed in
+ .IR locals .
+ .TP 5
++.I supplsX
++List of domain names that the current host
++will deliver on supplemental channel X where X is an integer starting at 0,
++one per line.
++No default.
++.TP 5
+ .I percenthack
+ List of domain names where the percent hack is applied.
+ If
+@@ -164,7 +198,9 @@
+ handles
+ .I percenthack
+ before
+-.IR locals .
++.I locals
++and
++.IR supplsX.
+ .TP 5
+ .I queuelifetime
+ Number of seconds
 diff -ruN ../netqmail-1.06-original/qmail-send.c netqmail-1.06/qmail-send.c
 --- ../netqmail-1.06-original/qmail-send.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-send.c	2016-11-22 21:03:57.124527699 +0100
-@@ -31,6 +31,7 @@
++++ netqmail-1.06/qmail-send.c	2019-06-26 16:42:40.004753618 +0200
+@@ -31,6 +31,11 @@
  #include "constmap.h"
  #include "fmtqfn.h"
  #include "readsubdir.h"
 +#include "srs.h"
++
++#include "auto_spawn.h"
++
++#include "channels.h"
  
  /* critical timing feature #1: if not triggered, do not busy-loop */
  /* critical timing feature #2: if triggered, respond within fixed time */
-@@ -44,6 +45,8 @@
+@@ -44,6 +49,8 @@
  
  int lifetime = 604800;
@@ -22559,5 +22318,5 @@
  struct constmap mappercenthack;
  stralloc locals = {0};
-@@ -55,6 +58,7 @@
+@@ -55,17 +62,20 @@
  stralloc bouncehost = {0};
  stralloc doublebounceto = {0};
@@ -22567,5 +22326,25 @@
  char strnum2[FMT_ULONG];
  char strnum3[FMT_ULONG];
-@@ -82,9 +86,6 @@
+ 
+-#define CHANNELS 2
+-char *chanaddr[CHANNELS] = { "local/", "remote/" };
+-char *chanstatusmsg[CHANNELS] = { " local ", " remote " };
+-char *tochan[CHANNELS] = { " to local ", " to remote " };
+-int chanfdout[CHANNELS] = { 1, 3 };
+-int chanfdin[CHANNELS] = { 2, 4 };
+-int chanskip[CHANNELS] = { 10, 20 };
++char *chanaddr[CHANNELS];
++char *chanstatusmsg[CHANNELS];
++char *tochan[CHANNELS];
++int chanfdout[CHANNELS];
++int chanfdin[CHANNELS];
++int chanskip[CHANNELS];
++struct constmap mapsuppl[SUPPL_CHANNELS];
++stralloc suppls[SUPPL_CHANNELS];
++stralloc newsuppls[SUPPL_CHANNELS];
+ 
+ int flagexitasap = 0; void sigterm() { flagexitasap = 1; }
+ int flagrunasap = 0; void sigalrm() { flagrunasap = 1; }
+@@ -82,12 +92,10 @@
  
  datetime_sec recent;
@@ -22577,5 +22356,9 @@
  stralloc fn2 = {0};
  char fnmake_strnum[FMT_ULONG];
-@@ -96,7 +97,7 @@
++stralloc fname = {0};
+ 
+ void fnmake_init()
+ {
+@@ -96,7 +104,7 @@
  }
  
@@ -22586,5 +22369,37 @@
  void fnmake_foop(id) unsigned long id; { fn.len = fmtqfn(fn.s,"foop/",id,0); }
  void fnmake_split(id) unsigned long id; { fn.len = fmtqfn(fn.s,"",id,1); }
-@@ -262,6 +263,8 @@
+@@ -117,6 +125,7 @@
+ {
+   int i;
+   int j;
++  int c;
+   char *x;
+   static stralloc addr = {0};
+   int at;
+@@ -159,6 +168,13 @@
+  
+   if (!stralloc_cat(&rwline,&addr)) return 0;
+   if (!stralloc_0(&rwline)) return 0;
++
++  for (c = 0;c < SUPPL_CHANNELS;++c)
++  {
++      if (constmap(&mapsuppl[c],addr.s + at + 1,addr.len - at - 1))
++          return c + 3;
++  }
++
+   return 2;
+ }
+ 
+@@ -228,7 +244,8 @@
+ 
+ substdio sstoqc; char sstoqcbuf[1024];
+ substdio ssfromqc; char ssfromqcbuf[1024];
+-stralloc comm_buf[CHANNELS] = { {0}, {0} };
++
++stralloc comm_buf[CHANNELS];
+ int comm_pos[CHANNELS];
+ 
+ void comm_init()
+@@ -262,6 +279,8 @@
   while (!stralloc_copys(&comm_buf[c],"")) nomem();
   ch = delnum;
@@ -22595,5 +22410,14 @@
   while (!stralloc_cats(&comm_buf[c],fn.s)) nomem();
   while (!stralloc_0(&comm_buf[c])) nomem();
-@@ -683,15 +686,39 @@
+@@ -382,7 +401,7 @@
+ /* this file is too long ----------------------------------- PRIORITY QUEUES */
+ 
+ prioq pqdone = {0}; /* -todo +info; HOPEFULLY -local -remote */
+-prioq pqchan[CHANNELS] = { {0}, {0} };
++prioq pqchan[CHANNELS];
+ /* pqchan 0: -todo +info +local ?remote */
+ /* pqchan 1: -todo +info ?local +remote */
+ prioq pqfail = {0}; /* stat() failure; has to be pqadded again */
+@@ -683,15 +702,39 @@
    }
   if (str_equal(sender.s,"#@[]"))
@@ -22638,5 +22462,5 @@
     qmail_put(&qqt,newfield_date.s,newfield_date.len);
     qmail_puts(&qqt,"From: ");
-@@ -740,9 +767,17 @@
+@@ -740,9 +783,17 @@
       qmail_fail(&qqt);
     else
@@ -22657,5 +22481,28 @@
       if (r == -1)
         qmail_fail(&qqt);
-@@ -906,41 +941,42 @@
+@@ -780,8 +831,8 @@
+ ;
+ 
+ unsigned long masterdelid = 1;
+-unsigned int concurrency[CHANNELS] = { 10, 20 };
+-unsigned int concurrencyused[CHANNELS] = { 0, 0 };
++unsigned int concurrency[CHANNELS];
++unsigned int concurrencyused[CHANNELS];
+ struct del *d[CHANNELS];
+ stralloc dline[CHANNELS];
+ char delbuf[2048];
+@@ -808,9 +859,9 @@
+  for (c = 0;c < CHANNELS;++c)
+   {
+    flagspawnalive[c] = 1;
+-   while (!(d[c] = (struct del *) alloc(concurrency[c] * sizeof(struct del))))
++   while (!(d[c] = (struct del *) alloc(auto_spawn * sizeof(struct del))))
+      nomem();
+-   for (i = 0;i < concurrency[c];++i)
++   for (i = 0;i < auto_spawn;++i)
+     { d[c][i].used = 0; d[c][i].recip.s = 0; }
+    dline[c].s = 0;
+    while (!stralloc_copys(&dline[c],"")) nomem();
+@@ -906,41 +957,42 @@
       dline[c].len = REPORTMAX;
       /* qmail-lspawn and qmail-rspawn are responsible for keeping it short */
@@ -22665,6 +22512,7 @@
      {
       delnum = (unsigned int) (unsigned char) dline[c].s[0];
+-     if ((delnum < 0) || (delnum >= concurrency[c]) || !d[c][delnum].used)
 +     delnum += (unsigned int) ((unsigned int) dline[c].s[1]) << 8;
-      if ((delnum < 0) || (delnum >= concurrency[c]) || !d[c][delnum].used)
++     if ((delnum < 0) || (delnum >= auto_spawn) || !d[c][delnum].used)
         log1("warning: internal error: delivery report out of range\n");
       else
@@ -22708,5 +22556,5 @@
  	   --jo[d[c][delnum].j].numtodo;
  	   break;
-@@ -1215,8 +1251,10 @@
+@@ -1215,8 +1267,10 @@
  
  /* this file is too long ---------------------------------------------- TODO */
@@ -22720,5 +22568,5 @@
  char todobuf[SUBSTDIO_INSIZE];
  char todobufinfo[512];
-@@ -1224,7 +1262,7 @@
+@@ -1224,7 +1278,7 @@
  
  void todo_init()
@@ -22729,5 +22577,5 @@
   trigger_set();
  }
-@@ -1236,7 +1274,7 @@
+@@ -1236,7 +1290,7 @@
  {
   if (flagexitasap) return;
@@ -22738,5 +22586,5 @@
  }
  
-@@ -1253,8 +1291,7 @@
+@@ -1253,8 +1307,7 @@
   char ch;
   int match;
@@ -22748,5 +22596,5 @@
   unsigned long uid;
   unsigned long pid;
-@@ -1265,32 +1302,26 @@
+@@ -1265,32 +1318,26 @@
  
   if (flagexitasap) return;
@@ -22790,5 +22638,21 @@
   fnmake_todo(id);
  
-@@ -1438,10 +1469,148 @@
+@@ -1363,12 +1410,9 @@
+        log1("\n");
+        break;
+      case 'T':
+-       switch(rewrite(todoline.s + 1))
+-	{
+-	 case 0: nomem(); goto fail;
+-	 case 2: c = 1; break;
+-	 default: c = 0; break;
+-        }
++       c = rewrite(todoline.s + 1);
++       if (c == 0) { nomem(); goto fail; }
++       c--;
+        if (fdchan[c] == -1)
+ 	{
+ 	 fnmake_chanaddr(id,c);
+@@ -1438,17 +1482,175 @@
     if (fdchan[c] != -1) close(fdchan[c]);
  }
@@ -22845,20 +22709,24 @@
 +
 + for (c = 0;c < CHANNELS;++c) flagchan[c] = 0;
-+ switch(*s++) {
-+  case 'L':
-+    flagchan[0] = 1;
-+    break;
-+  case 'R':
-+    flagchan[1] = 1;
-+    break;
-+  case 'B':
-+    flagchan[0] = 1;
-+    flagchan[1] = 1;
-+    break;
-+  case 'X':
-+    break;
-+  default:
-+    log1("warning: qmail-send unable to understand qmail-todo\n");
-+    return;
++
++ for (c = 0;c < CHANNELS;++c)
++ {
++  if (!*s)
++  {
++     log1("warning: qmail-send unable to understand qmail-todo\n");
++     return;
++  }
++
++  switch(*s++) {
++   case '0':
++     flagchan[c] = 0;
++     break;
++   case '1':
++     flagchan[c] = 1;
++     break;
++   default:
++     log1("warning: qmail-send unable to understand qmail-todo\n");
++     return;
++  }
 + }
 + 
@@ -22934,10 +22802,25 @@
  /* this file is too long ---------------------------------------------- MAIN */
  
- int getcontrols() { if (control_init() == -1) return 0;
-+ if (control_readint(&bouncemaxbytes,"control/bouncemaxbytes") == -1) return 0;   
+-int getcontrols() { if (control_init() == -1) return 0;
++int getcontrols() {
++ int c;
++ int ck = 0;
++
++ if (control_init() == -1) return 0;
++ if (control_readint(&bouncemaxbytes,"control/bouncemaxbytes") == -1) return 0;
   if (control_readint(&lifetime,"control/queuelifetime") == -1) return 0;
   if (control_readint(&concurrency[0],"control/concurrencylocal") == -1) return 0;
   if (control_readint(&concurrency[1],"control/concurrencyremote") == -1) return 0;
-@@ -1449,6 +1618,8 @@
++
++ for (c = 2,ck = 0;c < CHANNELS;++c)
++ {
++     strnum2[fmt_uint(strnum2,ck++)] = 0;
++     if (!stralloc_copys(&fname,"control/concurrencysuppl")) return 0;
++     if (!stralloc_cats(&fname,strnum2)) return 0;
++     if (!stralloc_0(&fname)) return 0;
++     if (control_readint(&concurrency[c],fname.s) == -1) return 0;
++ }
++
+  if (control_rldef(&envnoathost,"control/envnoathost",1,"envnoathost") != 1) return 0;
   if (control_rldef(&bouncefrom,"control/bouncefrom",0,"MAILER-DAEMON") != 1) return 0;
   if (control_rldef(&bouncehost,"control/bouncehost",1,"bouncehost") != 1) return 0;
@@ -22948,5 +22831,50 @@
   if (!stralloc_cats(&doublebounceto,"@")) return 0;
   if (!stralloc_cat(&doublebounceto,&doublebouncehost)) return 0;
-@@ -1478,6 +1649,10 @@
+@@ -1467,6 +1669,21 @@
+    case 0: if (!constmap_init(&mapvdoms,"",0,1)) return 0; break;
+    case 1: if (!constmap_init(&mapvdoms,vdoms.s,vdoms.len,1)) return 0; break;
+   }
++
++ for (c = 0;c < SUPPL_CHANNELS;++c)
++ {
++     strnum2[fmt_uint(strnum2,c)] = 0;
++     if (!stralloc_copys(&fname,"control/suppls")) return 0;
++     if (!stralloc_cats(&fname,strnum2)) return 0;
++     if (!stralloc_0(&fname)) return 0;
++     switch (control_readfile(&suppls[c],fname.s,0))
++     {
++         case -1: return 0;
++         case 0: if (!constmap_init(&mapsuppl[c],"",0,0)) return 0; break;
++         case 1: if (!constmap_init(&mapsuppl[c],suppls[c].s,suppls[c].len,0)) return 0; break;
++     }
++ }
++
+  return 1; }
+ 
+ stralloc newlocals = {0};
+@@ -1475,9 +1692,33 @@
+ void regetcontrols()
+ {
+  int r;
++ int c;
++ int ck = 0;
++
++ if (control_readint(&concurrency[0],"control/concurrencylocal") == -1)
++  { log1("alert: unable to reread control/concurrencylocal\n"); return; }
++ if (control_readint(&concurrency[1],"control/concurrencyremote") == -1)
++  { log1("alert: unable to reread control/concurrencyremote\n"); return; }
++
++ for (c = 2,ck = 0;c < CHANNELS;++c)
++ {
++     strnum2[fmt_uint(strnum2,ck++)] = 0;
++     if (!stralloc_copys(&fname,"control/concurrencysuppl"))
++         { log3("alert: unable to reread ",fname.s,"\n"); return; }
++     if (!stralloc_cats(&fname,strnum2))
++         { log3("alert: unable to reread ",fname.s,"\n"); return; }
++     if (!stralloc_0(&fname))
++         { log3("alert: unable to reread ",fname.s,"\n"); return; }
++     if (control_readint(&concurrency[c],fname.s) == -1)
++         { log3("alert: unable to reread ",fname.s,"\n"); return; }
++ }
  
   if (control_readfile(&newlocals,"control/locals",1) != 1)
@@ -22959,5 +22887,34 @@
   if (r == -1)
    { log1("alert: unable to reread control/virtualdomains\n"); return; }
-@@ -1504,6 +1679,9 @@
+@@ -1495,6 +1736,28 @@
+   }
+  else
+    while (!constmap_init(&mapvdoms,"",0,1)) nomem();
++
++ for (c = 0;c < SUPPL_CHANNELS;++c)
++ {
++     strnum2[fmt_uint(strnum2,c)] = 0;
++     if (!stralloc_copys(&fname,"control/suppls")) nomem();
++     if (!stralloc_cats(&fname,strnum2)) nomem();
++     if (!stralloc_0(&fname)) nomem();
++     r = control_readfile(&newsuppls[c],fname.s,0);
++     if (r == -1)
++      { log3("alert: qmail-todo: unable to reread ", fname.s, "\n"); return; }
++
++     constmap_free(&mapsuppl[c]);
++
++     if (r)
++      {
++       while (!stralloc_copy(&suppls[c],&newsuppls[c])) nomem();
++       while (!constmap_init(&mapsuppl[c],suppls[c].s,suppls[c].len,0)) nomem();
++      }
++     else
++       while (!constmap_init(&mapsuppl[c],"",0,0)) nomem();
++ }
++
+ }
+ 
+ void reread()
+@@ -1504,6 +1767,9 @@
     log1("alert: unable to reread controls: unable to switch to home directory\n");
     return;
@@ -22969,5 +22926,119 @@
   while (chdir("queue") == -1)
    {
-@@ -1544,7 +1722,7 @@
+@@ -1512,6 +1778,104 @@
+   }
+ }
+ 
++
++static int static_i = 0;
++static int static_j = 0;
++static void channels_init(void)
++{
++    chanaddr[0] = "local/";
++    chanaddr[1] = "remote/";
++    for (static_i=2,static_j=0;static_i<CHANNELS;static_i++,static_j++)
++    {
++        stralloc fnc = {0};
++        strnum2[fmt_uint(strnum2,static_j)] = 0;
++        if (!stralloc_copys(&fname,QDIR_BASENAME)) nomem();
++        if (!stralloc_cats(&fname,strnum2)) nomem();
++        if (!stralloc_cats(&fname,"/")) nomem();
++        if (!stralloc_0(&fname)) nomem();
++        if (!stralloc_copy(&fnc,&fname)) nomem();
++        chanaddr[static_i] = fnc.s;
++    }
++
++    chanstatusmsg[0] = " local ";
++    chanstatusmsg[1] = " remote ";
++    for (static_i=2,static_j=0;static_i<CHANNELS;static_i++,static_j++)
++    {
++        stralloc fnc = {0};
++        strnum2[fmt_uint(strnum2,static_j)] = 0;
++        if (!stralloc_copys(&fname," " QDIR_BASENAME)) nomem();
++        if (!stralloc_cats(&fname,strnum2)) nomem();
++        if (!stralloc_cats(&fname," ")) nomem();
++        if (!stralloc_0(&fname)) nomem();
++        if (!stralloc_copy(&fnc,&fname)) nomem();
++        chanstatusmsg[static_i] = fnc.s;
++    }
++
++    tochan[0] = " to local ";
++    tochan[1] = " to remote ";
++    static_j = 0;
++    for (static_i=2;static_i<CHANNELS;static_i++)
++    {
++        stralloc fnc = {0};
++        strnum2[fmt_uint(strnum2,static_j++)] = 0;
++        if (!stralloc_copys(&fname," to " QDIR_BASENAME)) nomem();
++        if (!stralloc_cats(&fname,strnum2)) nomem();
++        if (!stralloc_cats(&fname," ")) nomem();
++        if (!stralloc_0(&fname)) nomem();
++        if (!stralloc_copy(&fnc,&fname)) nomem();
++        tochan[static_i] = fnc.s;
++    }
++
++    chanfdout[0] = 1;
++    chanfdout[1] = 3;
++    static_j = 1+CHANNEL_FD_OFFSET;
++    for (static_i=2;static_i<CHANNELS;static_i++)
++    {
++        chanfdout[static_i] = static_j;
++        static_j+=2;
++    }
++
++    chanfdin[0] = 2;
++    chanfdin[1] = 4;
++    static_j = 2+CHANNEL_FD_OFFSET;
++    for (static_i=2;static_i<CHANNELS;static_i++)
++    {
++        chanfdin[static_i] = static_j;
++        static_j+=2;
++    }
++
++    chanskip[0] = 10;
++    chanskip[1] = 20;
++    static_j = 20;
++    for (static_i=2;static_i<CHANNELS;static_i++)
++    {
++        chanskip[static_i] = static_j;
++    }
++
++    for (static_i=0;static_i<CHANNELS;static_i++)
++        comm_buf[static_i].s = 0;
++
++    for (static_i=0;static_i<CHANNELS;static_i++)
++        pqchan[static_i].p = 0;
++
++    concurrency[0] = 10;
++    concurrency[1] = 20;
++    for (static_i=2;static_i<CHANNELS;static_i++)
++    {
++        concurrency[static_i] = 20;
++    }
++
++    for (static_i=0;static_i<CHANNELS;static_i++)
++        concurrencyused[static_i] = 0;
++
++    for (static_i=0;static_i<SUPPL_CHANNELS;static_i++)
++        suppls[static_i].s = 0;
++
++    for (static_i=0;static_i<SUPPL_CHANNELS;static_i++)
++        newsuppls[static_i].s = 0;
++
++}
++
+ void main()
+ {
+  int fd;
+@@ -1522,6 +1886,8 @@
+  struct timeval tv;
+  int c;
+ 
++ channels_init();
++
+  if (chdir(auto_qmail) == -1)
+   { log1("alert: cannot start: unable to switch to home directory\n"); _exit(111); }
+  if (!getcontrols())
+@@ -1544,7 +1910,7 @@
   numjobs = 0;
   for (c = 0;c < CHANNELS;++c)
@@ -22978,5 +23049,5 @@
     int r;
     do
-@@ -1552,7 +1730,13 @@
+@@ -1552,7 +1918,13 @@
     while ((r == -1) && (errno == error_intr));
     if (r < 1)
@@ -22992,5 +23063,5 @@
     numjobs += concurrency[c];
    }
-@@ -1568,7 +1752,11 @@
+@@ -1568,7 +1940,11 @@
   todo_init();
   cleanup_init();
@@ -23006,5 +23077,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-showctl.c netqmail-1.06/qmail-showctl.c
 --- ../netqmail-1.06-original/qmail-showctl.c	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-showctl.c	2016-11-28 19:39:45.341600337 +0100
++++ netqmail-1.06/qmail-showctl.c	2019-02-27 20:57:13.401024948 +0100
 @@ -15,6 +15,7 @@
  #include "auto_patrn.h"
@@ -23126,5 +23197,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-smtpd.8 netqmail-1.06/qmail-smtpd.8
 --- ../netqmail-1.06-original/qmail-smtpd.8	1998-06-15 12:53:16.000000000 +0200
-+++ netqmail-1.06/qmail-smtpd.8	2016-12-18 19:08:22.496459855 +0100
++++ netqmail-1.06/qmail-smtpd.8	2019-02-27 20:57:13.402024937 +0100
 @@ -14,6 +14,15 @@
  see
@@ -23450,5 +23521,5 @@
 diff -ruN ../netqmail-1.06-original/qmail-smtpd.c netqmail-1.06/qmail-smtpd.c
 --- ../netqmail-1.06-original/qmail-smtpd.c	2007-11-30 21:22:54.000000000 +0100
-+++ netqmail-1.06/qmail-smtpd.c	2017-11-07 17:45:04.599607652 +0100
++++ netqmail-1.06/qmail-smtpd.c	2020-04-25 15:15:28.957053097 +0200
 @@ -12,6 +12,9 @@
  #include "ip.h"
@@ -23461,5 +23532,5 @@
  #include "scan.h"
  #include "byte.h"
-@@ -23,44 +26,178 @@
+@@ -23,44 +26,180 @@
  #include "timeoutread.h"
  #include "timeoutwrite.h"
@@ -23467,44 +23538,6 @@
 +#include "dns.h"
 +#include "wait.h"
-+/* start chkuser code */
-+#include "chkuser.h"
-+/* end chkuser code */
-+#include "spf.h"
-+/* rbl: start */
-+#include "strsalloc.h"
-+/* rbl: end */
-+
-+#define AUTHSLEEP 5
- 
- #define MAXHOPS 100
-+
-+#define BMCHECK_BMF 0
-+#define BMCHECK_BMFNR 1
-+#define BMCHECK_BMT 2
-+#define BMCHECK_BMTNR 3
-+#define BMCHECK_BHELO 4
-+#define BMCHECK_BHELONR 5
-+
-+static char strnum[FMT_ULONG];
- unsigned int databytes = 0;
-+unsigned int greetdelay = 0;
-+unsigned int drop_pre_greet = 0;
- int timeout = 1200;
-+int maxrcpt = -1;
-+unsigned int spfbehavior = 0;
-+
-+/* rejectrelaytest: start */
-+unsigned int rejectrelaytest = 0;
-+/* rejecrelayttest: end */
-+/* rejectnullsenders: start */
-+unsigned int rejnsmf = 0;
-+/* rejectnullsenders: end */
-+
-+const char *protocol = "SMTP";
-+
-+/* spf ipv6 fix */
-+char *remoteip4;
-+/* end spf ipv6 fix */
-+
++
++/* chkuser.h will check if TLS_H is defined, so this has to come before chkuser.h */
 +#ifdef TLS
 +#include <sys/stat.h>
@@ -23517,4 +23550,44 @@
 +int forcetls = 1;
 +#endif
++
++/* start chkuser code */
++#include "chkuser.h"
++/* end chkuser code */
++#include "spf.h"
++/* rbl: start */
++#include "strsalloc.h"
++/* rbl: end */
++
++#define AUTHSLEEP 5
+ 
+ #define MAXHOPS 100
++
++#define BMCHECK_BMF 0
++#define BMCHECK_BMFNR 1
++#define BMCHECK_BMT 2
++#define BMCHECK_BMTNR 3
++#define BMCHECK_BHELO 4
++#define BMCHECK_BHELONR 5
++
++static char strnum[FMT_ULONG];
+ unsigned int databytes = 0;
++unsigned int greetdelay = 0;
++unsigned int drop_pre_greet = 0;
+ int timeout = 1200;
++int maxrcpt = -1;
++unsigned int spfbehavior = 0;
++
++/* rejectrelaytest: start */
++unsigned int rejectrelaytest = 0;
++/* rejecrelayttest: end */
++/* rejectnullsenders: start */
++unsigned int rejnsmf = 0;
++/* rejectnullsenders: end */
++
++static const char *protocol = "SMTP";
++
++/* spf ipv6 fix */
++char *remoteip4;
++/* end spf ipv6 fix */
  
  int safewrite(fd,buf,len) int fd; char *buf; int len;
@@ -23555,5 +23628,5 @@
 -void die_ipme() { out("421 unable to figure out my IP addresses (#4.3.0)\r\n"); flush(); _exit(1); }
 -void straynewline() { out("451 See http://pobox.com/~djb/docs/smtplf.html.\r\n"); flush(); _exit(1); }
-+void die_read() { logit("read failed"); _exit(1); }
++void die_read(char *reason) { logit2("read failed", reason); flush(); _exit(1); }
 +void die_alarm() { qlogenvelope("rejected","alarmtimeout","","451"); logit("timeout"); out("451 timeout (#4.4.2)\r\n"); flush(); _exit(1); }
 +void die_nomem() { qlogenvelope("rejected","outofmemory","","421"); out("421 out of memory (#4.3.0)\r\n"); flush(); _exit(1); }
@@ -23649,5 +23722,5 @@
  void smtp_greet(code) char *code;
  {
-@@ -76,11 +213,33 @@
+@@ -76,11 +215,33 @@
    smtp_greet("221 "); out("\r\n"); flush(); _exit(0);
  }
@@ -23683,5 +23756,5 @@
  stralloc helohost = {0};
  char *fakehelo; /* pointer into helohost, or 0 */
-@@ -91,11 +250,101 @@
+@@ -91,11 +252,101 @@
    fakehelo = case_diffs(remotehost,helohost.s) ? helohost.s : 0;
  }
@@ -23786,5 +23859,5 @@
  void setup()
  {
-@@ -109,21 +358,110 @@
+@@ -109,21 +360,110 @@
    if (liphostok == -1) die_control();
    if (control_readint(&timeout,"control/timeoutsmtpd") == -1) die_control();
@@ -23898,5 +23971,5 @@
    if (!local) local = env_get("TCPLOCALIP");
    if (!local) local = "unknown";
-@@ -131,10 +469,67 @@
+@@ -131,10 +471,67 @@
    if (!remotehost) remotehost = "unknown";
    remoteinfo = env_get("TCPREMOTEINFO");
@@ -23967,5 +24040,5 @@
  
  int addrparse(arg)
-@@ -155,6 +550,7 @@
+@@ -155,6 +552,7 @@
      terminator = ' ';
      arg += str_chr(arg,':');
@@ -23975,5 +24048,5 @@
    }
  
-@@ -197,6 +593,8 @@
+@@ -197,6 +595,8 @@
    return 1;
  }
@@ -23984,5 +24057,5 @@
  {
    int j;
-@@ -207,68 +605,1102 @@
+@@ -207,76 +607,1108 @@
      if (constmap(&mapbmf,addr.s + j,addr.len - j - 1)) return 1;
    return 0;
@@ -24459,57 +24532,48 @@
 +}
 +
-+void logit(message) const char* message;
++/* logging patch */
++
++void safeloglen(const char* string, const int len) {
++    if (string && len) {
++        if (!stralloc_catb(&log_buf, string, len-1)) die_nomem();
++    } else {
++        if (!stralloc_catb(&log_buf, "(null)", 6)) die_nomem();
++    }
++}
++
++void safelog(const char* string) {
++    if (string) {
++        if (!stralloc_cats(&log_buf, string)) die_nomem();
++    } else {
++        if (!stralloc_catb(&log_buf, "(null)", 6)) die_nomem();
++    }
++}
++
++void logit(const char* message) {
++    logit2(message, (const char*)0);
++}
++
++void logit2(const char* message, const char* reason)
 +{
 +  if (!stralloc_copys(&log_buf, "qmail-smtpd: ")) die_nomem();
-+  if (!stralloc_cats(&log_buf, message)) die_nomem();
++  safelog(message);
++  if (reason) {
++      if (!stralloc_cats(&log_buf, " (")) die_nomem();
++      if (!stralloc_cats(&log_buf, reason)) die_nomem();
++      if (!stralloc_cats(&log_buf, ")")) die_nomem();
++  }
 +  if (!stralloc_catb(&log_buf, ": ", 2)) die_nomem();
-+  if (mailfrom.s) {
-+      if (!stralloc_catb(&log_buf, mailfrom.s, mailfrom.len-1)) die_nomem();
-+  } else
-+      if (!stralloc_catb(&log_buf, "(null)", 6)) die_nomem();
++  safeloglen(mailfrom.s, mailfrom.len);
 +  if (!stralloc_catb(&log_buf, " from ", 6)) die_nomem();
-+  if (!stralloc_cats(&log_buf, remoteip)) die_nomem();
++  safelog(remoteip);
 +  if (!stralloc_catb(&log_buf, " to ", 4)) die_nomem();
-+  if (addr.s) {
-+      if (!stralloc_catb(&log_buf, addr.s, addr.len-1)) die_nomem();
-+  } else
-+      if (!stralloc_catb(&log_buf, "(null)", 6)) die_nomem();
++  safeloglen(addr.s, addr.len);
 +  if (!stralloc_catb(&log_buf, " helo ", 6)) die_nomem();
-+  if (helohost.s) {
-+      if (!stralloc_catb(&log_buf, helohost.s, helohost.len-1)) die_nomem();
-+  } else
-+      if (!stralloc_catb(&log_buf, "(null)", 6)) die_nomem();
++  safeloglen(helohost.s, helohost.len);
 +  if (!stralloc_catb(&log_buf, "\n", 1)) die_nomem();
 +  substdio_putflush(&sserr, log_buf);
 +}
 +
-+void logit2(message, reason)
-+const char* message;
-+const char* reason;
-+{
-+  if (!stralloc_copys(&log_buf,"qmail-smtpd: ")) die_nomem();
-+  if (!stralloc_cats(&log_buf, message)) die_nomem();
-+  if (!stralloc_cats(&log_buf, " (")) die_nomem();
-+  if (!stralloc_cats(&log_buf, reason)) die_nomem();
-+  if (!stralloc_cats(&log_buf, "): ")) die_nomem();
-+  if (mailfrom.s) {
-+      if (!stralloc_catb(&log_buf, mailfrom.s, mailfrom.len-1)) die_nomem();
-+  } else
-+      if (!stralloc_catb(&log_buf, "(null)", 6)) die_nomem();
-+  if (!stralloc_cats(&log_buf," from ")) die_nomem();
-+  if (!stralloc_cats(&log_buf, remoteip)) die_nomem();
-+  if (!stralloc_cats(&log_buf, " to ")) die_nomem();
-+  if (addr.s) {
-+      if (!stralloc_catb(&log_buf, addr.s, addr.len-1)) die_nomem();
-+  } else
-+      if (!stralloc_catb(&log_buf, "(null)", 6)) die_nomem();
-+  if (!stralloc_cats(&log_buf, " helo ")) die_nomem();
-+  if (helohost.s) {
-+      if (!stralloc_catb(&log_buf, helohost.s, helohost.len-1)) die_nomem();
-+  } else
-+      if (!stralloc_catb(&log_buf, "(null)", 6)) die_nomem();
-+  if (!stralloc_catb(&log_buf, "\n", 1)) die_nomem();
-+  substdio_putflush(&sserr, log_buf);
-+}
++/* end logging patch */
 +
 +int mailfrom_size(arg) char *arg;
@@ -24543,5 +24607,5 @@
 +  if (!remoteinfo) {
 +    remoteinfo = fuser.s;
-+    if (!env_unset("TCPREMOTEINFO")) die_read();
++    if (!env_unset("TCPREMOTEINFO")) die_read("TCPREMOTEINFO");
 +    if (!env_put2("TCPREMOTEINFO",remoteinfo)) die_nomem();
 +  }
@@ -24577,5 +24641,5 @@
 +  if (bhelook) flagbarfbhelo = bmcheck(BMCHECK_BHELO);
 +  if ((!flagbarfbhelo) && (bhelonrok) && (!relayclient)) flagbarfbhelo = bmcheck(BMCHECK_BHELONR);
-+}
+ }
 +char size_buf[FMT_ULONG];
 +void smtp_size()
@@ -24583,5 +24647,5 @@
 +  size_buf[fmt_ulong(size_buf,(unsigned long) databytes)] = 0;
 +  out("250 SIZE "); out(size_buf); out("\r\n");
- }
++}
 +
 +/* ESMTP extensions are published here */
@@ -24620,4 +24684,8 @@
 +  seenmail = 0; /* seenauth = 0; RFC 5321: retain authentication */
 +  mailfrom.len = 0; rcptto.len = 0;
++  /* prevents the maxrcpto error if control/maxrcpt limit has been exceeded in the same email, but not in multiple messages sequentially */
++  rcptcount = 0;
++  envelopepos = 1;
++  /* end rcptcount adjustment */
    out("250 flushed\r\n");
  }
@@ -24669,5 +24737,5 @@
 +/* qregex: start */
 +  /*
-+  flagbarf = bmfcheck();
+   flagbarf = bmfcheck();
 +  */
 +  flagbarfbmf = 0; /* bmcheck is skipped for empty envelope senders */
@@ -24683,5 +24751,5 @@
 +/* qregex: start */
 +  /*
-   flagbarf = bmfcheck();
++  flagbarf = bmfcheck();
 +  */
 +  flagbarfbmf = 0; /* bmcheck is skipped for empty envelope senders */
@@ -25091,6 +25159,8 @@
    r = timeoutread(timeout,fd,buf,len);
    if (r == -1) if (errno == error_timeout) die_alarm();
-   if (r <= 0) die_read();
-@@ -277,6 +1709,9 @@
+-  if (r <= 0) die_read();
++  if (r <= 0) die_read("hang up before quit cmd");
+   return r;
+ }
  
  char ssinbuf[1024];
@@ -25102,5 +25172,5 @@
  struct qmail qqt;
  unsigned int bytestooverflow = 0;
-@@ -300,7 +1735,7 @@
+@@ -300,7 +1732,7 @@
    int flagmaybex; /* 1 if this line might match RECEIVED, if fih */
    int flagmaybey; /* 1 if this line might match \r\n, if fih */
@@ -25111,5 +25181,5 @@
    *hops = 0;
    flaginheader = 1;
-@@ -322,17 +1757,16 @@
+@@ -322,17 +1754,16 @@
      }
      switch(state) {
@@ -25132,5 +25202,5 @@
          state = 0;
          break;
-@@ -351,10 +1785,73 @@
+@@ -351,10 +1782,73 @@
    }
  }
@@ -25206,5 +25276,5 @@
    out("250 ok ");
    accept_buf[fmt_ulong(accept_buf,(unsigned long) when)] = 0;
-@@ -363,22 +1860,32 @@
+@@ -363,22 +1857,32 @@
    accept_buf[fmt_ulong(accept_buf,qp)] = 0;
    out(accept_buf);
@@ -25241,5 +25311,5 @@
    hops = (hops >= MAXHOPS);
    if (hops) qmail_fail(&qqt);
-@@ -386,34 +1893,631 @@
+@@ -386,36 +1890,662 @@
    qmail_put(&qqt,rcptto.s,rcptto.len);
   
@@ -25282,5 +25352,5 @@
 +    if (!stralloc_readyplus(&authin,1)) die_nomem(); /* XXX */
 +    i = substdio_get(&ssin,authin.s + authin.len,1);
-+    if (i != 1) die_read();
++    if (i != 1) die_read("authgetl");
 +    if (authin.s[authin.len] == '\n') break;
 +    ++authin.len;
